package stftr.protocols.Distribute;

import appia.*;
import appia.events.*;
import appia.protocols.tcpcomplete.TcpUndeliveredEvent;
import stftr.protocols.events.*;
import java.util.*;

/**
* // TODO: comentar
*/
public class DistributeSession extends Session {
    Hashtable connections; // playerID -> InetWithPort
    Hashtable players; // InetWithPort -> playerID

    /**
    * // TODO: comentar
    */
    public DistributeSession(DistributeLayer l) {
        super(l);
        connections=new Hashtable();
        players=new Hashtable();
    }

    /**
    * // TODO: comentar
    */
    public void handle(Event e) {
        if (e instanceof TcpUndeliveredEvent) {
            handle((TcpUndeliveredEvent) e);
        } else if (e instanceof AddedPlayerEvent) {
            handle((AddedPlayerEvent) e);
        } else if (e instanceof KilledPlayerEvent) {
            handle((KilledPlayerEvent) e);
        } else if (e instanceof BoardEvent) {
            handle((BoardEvent) e);
        } else {
            System.err.println("[DistributeSession] Receiveived an unexpected event "+e);            
            System.exit(1);
        }
    }

    /**
    * Informs the server to remove the player and updates the internal tables.
    */
    void handle(TcpUndeliveredEvent e) {
        Integer playerID=(Integer) players.get(e.who);

        if (playerID==null) // tcp window... killed but trying to do an action...
            return;

        players.remove(connections.remove(playerID));

        try {
            e.go();

            RemovePlayerEvent removeEvent=new RemovePlayerEvent(playerID, e.getChannel(), new Direction(Direction.UP), this);
            removeEvent.go();
        } catch (Exception ex) {
            System.err.println("[DistributeSession] Error while trying to send an event.");
            ex.printStackTrace();
            System.exit(1);
        }
    }

    /**
    * Updates the internal tables.
    */
    void handle(AddedPlayerEvent e) {
        connections.put(e.getPlayerID(), e.dest);
        players.put(e.dest, e.getPlayerID());

        try {
            e.go();
        } catch (Exception ex) {
            System.err.println("[DistributeSession] Error in e.go().");
            ex.printStackTrace();
            System.exit(1);
        }
    }

    /**
    * Informs the player it was killed.
    */
    void handle(KilledPlayerEvent e) {
        e.dest=connections.get(e.dest);  // playerID -> InetWithPort

        if (e.dest==null) {
            System.err.println("[DistributeSession] An unknow player was killed.");
            return;
        }
        
        try {
            e.go();
        } catch (Exception ex) {
            System.err.println("[DistributeSession] Error in e.go().");
            ex.printStackTrace();
            System.exit(1);
        }
    }

    /**
    * Distributes the board to all the players.
    */
    void handle(BoardEvent e) {
        for (Enumeration enum=connections.elements(); enum.hasMoreElements(); ) {
            BoardEvent ev=(BoardEvent) e.clone();
            ev.setSource(this);
            ev.dest=enum.nextElement();
            
            try {
                ev.init();
                ev.go();
            } catch (Exception ex) {
                System.err.println("[DistributeSession] Error while distributing the board.");
                ex.printStackTrace();
                System.exit(1);
            }
        }
    }
}