package stftr.protocols.events;

import appia.*;
import appia.events.*;
import appia.protocols.group.events.ObjectsMessage;
import stftr.Board;

public class BoardEvent extends SendableEvent {
    private Board board;
    private Integer playerID;

    public BoardEvent() {
        super(new ObjectsMessage());
        board=null;
        playerID=null;
    }

    public BoardEvent(Board board, Integer playerID, Channel c, Direction d, Session s) throws AppiaEventException {
        super(c, d, s, new ObjectsMessage());
        ((ObjectsMessage) message).push(board);
        ((ObjectsMessage) message).push(playerID);
        this.board=board;
        this.playerID=playerID;
    }

    public Board getBoard() {
        if (board==null) {
            playerID=(Integer) ((ObjectsMessage) message).pop();
            board=(Board) ((ObjectsMessage) message).pop();
        }

        return board;
    }

    public Integer getPlayerID() {
        if (board==null) {
            playerID=(Integer) ((ObjectsMessage) message).pop();
            board=(Board) ((ObjectsMessage) message).pop();
        }
        
        return playerID;
    }

    public Object clone() {
        try {
            return new BoardEvent(board, playerID, getChannel(), getDirection(), currentSession());
        } catch (Exception e) {
            return null;
        }
    }
}