package stftr.protocols.events;

import appia.*;
import appia.protocols.group.events.ObjectsMessage;

public class PlayerActionEvent extends ActionEvent {
    /** move player up. (value is the same as stftr.GameServer.UP */
    public static final int UP=0;
    /** move player down. (value is the same as stftr.GameServer.DOWN */
    public static final int DOWN=1;
    /** move player left. (value is the same as stftr.GameServer.LEFT */
    public static final int LEFT=2;
    /** move player right. (value is the same as stftr.GameServer.RIGHT */
    public static final int RIGHT=3;
    /** player shoots the direction he's facing */
    public static final int SHOOT=4;

    private Integer playerID;
    private int action;

    public PlayerActionEvent() {
        super();
        playerID=null;
        action=-1;
    }

    public PlayerActionEvent(Integer playerID, int action, Channel c, Direction d, Session s) throws AppiaEventException {
        super(c, d, s);
        ((ObjectsMessage) message).push(playerID);
        ((ObjectsMessage) message).pushInt(action);

        this.playerID=playerID;
        this.action=action;
    }

    public Integer getPlayerID() {
        if (playerID==null) {
            action=((ObjectsMessage) message).popInt();
            playerID=(Integer) ((ObjectsMessage) message).pop();
        }

        return playerID;
    }

    public int getAction() {
        if (playerID==null) {
            action=((ObjectsMessage) message).popInt();
            playerID=(Integer) ((ObjectsMessage) message).pop();
        }

        return action;
    }
}